/*==========================================================================
* ACCBLANK.C - Copyright (c) 1994 ATI Technologies Inc. All rights reserved*
*                                                                          *
* PGL functions blank and unblank the screen for accelerator modes.        *
*                                                                          *
* ======================================================================== */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <memory.h>
#include <dos.h>

#include "..\inc\atim64.h"
#include "..\inc\pgl.h"
#include "..\inc\pglglob.h"

/* --------------------------------------------------------------------------
  PGL_blankscreen - blank the screen
  
  This is useful for avoiding visible artifacts on screen during a mode
  change or calling the query functions.
-------------------------------------------------------------------------- */
void PGL_blankscreen(void)
{
    ROM_setdpmscontrol(DPMS_OFF);
}

/* --------------------------------------------------------------------------
  PGL_unblankscreen - unblank the screen
  
  This is the counterpart function for PGL_blankscreen().
-------------------------------------------------------------------------- */
void PGL_unblankscreen(void)
{
    ROM_setdpmscontrol(DPMS_ACTIVE);
}

